package threads;

import java.util.ArrayList;
import java.util.List;

/*
 * Készítsünk programot, amely 10 másodpercen át 0 és 9 közti számokat ír ki a konzolra
 */
public class Threads2 {

    public static void main(String[] args) throws InterruptedException {
        List<NumberPrinter> printers = new ArrayList<>();
        // 10 db párhuzamosan futó szálként való megoldás
        for (int i = 0; i < 10; i++) {
            final int number = i;
            NumberPrinter numberPrinter =
                    new Threads2.NumberPrinter(number); // új runnable típusú objektum
            printers.add(numberPrinter); // elteszzük egy listába, hogy később is hozzáférjünk
            Thread thread =
                    new Thread(numberPrinter); // a runnable objektum szálba ágyazása
            thread.start(); // párhuzamos szál indítása            
        }
        // várunk 10 másodpercet
        Thread.sleep(10*1000);
        // leállítjuk a szálakat oly módon, hogy a runnable objektumainknak az
        // általunk definiált stop() műveletével kényszerítjük a run() függvényt
        // a leállásra
        for (NumberPrinter numberPrinter : printers) {
            numberPrinter.stop(); // ne tévesszük össze a szál objektumok stop() függvényével
        }
    }

    private static class NumberPrinter implements Runnable {

        private final int number;
        private boolean running = true;

        public NumberPrinter(int number) {
            this.number = number;
        }

        /*
         * Minden szál run() függvénye definiálja, hogy mit kell futás
         * közben a szálnak tennie
         */
        @Override
        public void run() {
            while (running) {
                System.out.println(number);
                Thread.yield(); // tájékoztatja az ütemezőt, hogy nem kell több CPU-idő
            }
        }

        private void stop() {
            running = false;
        }
    }
}
