package threads;

import java.awt.EventQueue;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.Timer;

/*
 * Készítsünk programot, amely 1 tizedmásodpercenként kiír egy betűt egy 
 * grafikus ablak szövegdobozába, amíg az ablakot be nem zárjuk.
 */
public class Threads4 extends JFrame {

    public static void main(String[] args) {
        // A grafikus felületen bármilyen műveletet csak az eseménykezelést
        // vezérlő szálon szabad végezni. Ennek az alábbi a módja:
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new Threads4().setVisible(true);
            }
        });
    }
    private final JTextArea textArea;

    public Threads4() throws HeadlessException {
        setTitle("Betűk");
        setSize(300, 200);
        setLocation(30, 30);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        textArea = new JTextArea();
        textArea.setLineWrap(true);
        getContentPane().add(new JScrollPane(textArea,
                JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                JScrollPane.HORIZONTAL_SCROLLBAR_NEVER));
        // a javax.swing.Timer típusú időzítőt az eseménykezelést vezérlő szál vezérli
        new Timer(100, new TimerActionListener()).start();
    }

    /*
     * Az időzítő a megadott időközönként kivált egy eseményt, amelyre
     * eseménykezelővel kell figyelni.
     */
    private class TimerActionListener implements ActionListener {

        private Random random = new Random();

        @Override
        public void actionPerformed(ActionEvent e) {
            textArea.append(String.valueOf((char) (random.nextInt(26) + 97)));
        }
    }
}
